<?php

/*
//  PHP Benchmarking code
//
//  Copyright (C) 2008 Beau -
//
//   This code is part of the website DoStuffRight.
//   This code will be known henceforth throughout the license as "Benchmark.php"
//
//   Benchmark.php is free software: you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation, either version 3 of the License, or
//   (at your option) any later version.
//
//   Benchmark.php is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with Benchmark.php.  If not, see <http://www.gnu.org/licenses/>.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

echo "<html>\n";
echo "	<body>\n";
echo "		<table border=1>\n";
echo "			<tr>\n";
echo "				<td>Command</td>\n";
echo "				<td>Time Difference</td>\n";
echo "				<td>Used in code</td>\n";
echo "				<td>Saved per page</td>\n";
echo "				<td>Saved per day</td>\n";
echo "				<td>Saved per year</td>\n";
echo "			</tr>\n";
set_time_limit(0);									//Allow the page as much time as it needs to load without causing an error.

/*Declare the globals*/

global $array1;										//$array1 holds the "complex" array.
global $array2;										//$array2 holds the "simple" array.
global $array3;										//$array3 holds the "long" array.
global $array4;										//$array4 holds the "short" array.
global $totaldifference;							//$totaldifference is the total amount of time saved by making the favorable changes.
global $totaloccurences;							//$totaloccurences is the number of times that all the commands I tested appear in my home page code.
global $totalperpage;								//$totalperpage is the amount of time that would be saved for each page load if I made all the favorable changes.
global $totalperday;								//$totalperday is the amount of time that would be saved each day at 200 page loads a day if I made all the changes.
global $totalperyear;								//$totalperyear is the amount of time that would be saved per year if I made all the favorable changes.
global $keys;										//$keys is an array used to hold the table names to build up the insert statement.
global $values;										//$values is an array used to hold the benchmark results to be put into the results table.

/*Initialize the variables*/

$tests=20;											//The number of times to run a command through the loop.
$loops=1000;										//The number of iterations in the test loop.
$totaldifference=0;
$totaloccurences=0;
$totalperpage=0;
$totalperday=0;
$totalperyear=0;
$array1=array(1=>"cat","dog"=>0,"red"=>"green",5=>4,3,"me");
$array2=array(1,1,1,1,1,1);
$i   = 0;
$tmp = '';
while($i < 10000) {
  $tmp .= 'a';
  ++$i;
}
$array3 = array_fill(100000000000000000000000, 100, $tmp);
$array4=array(1);

/*Begin the benchmarks*/

//The standard call to the compare_commands function is as follows:
//compare_commands(Display name for command one, command one, The column name in the results table, Display name for command two, command two, The column name in the results table, the number of times the particular command appears in DSR[false if 0], the number of tests to run[optional],the number of times to run the loop[optional]);
//IMPORTANT NOTE: Each command MUST contain something that bumps the variable $i. Failure to do so will create a never ending loop. An easy way to do this is just add: $i++; to the end of all your commands. Make sure you are consistent if you want to get accurate results. 

compare_commands('$i++','$i++;','vplusplus','++$i','++$i;','plusplusv',10,$tests,$loops);
compare_commands('echo','echo "<!---->";$i++;','echo','print','print "<!---->";$i++;','print',37,$tests,$loops);
compare_commands('Loop limit defined in','global $array3; $test=$array3; for($a=0; $a<count($test); $a++){}$i++;','defin','Loop limit defined first','global $array3; $test=$array3; $size=sizeof($test); for($a=0; $a<$size; $a++){}$i++;','deffirst',2,$tests,$loops);
compare_commands('While/List','$test=array(1=>"cat","dog"=>0,"red"=>"green",5=>4,3,"me"); while(list(,$t) = each($test)){} $i++;','whilelist','foreach','$test=array(1=>"cat","dog"=>0,"red"=>"green",5=>4,3,"me"); foreach($test as $t){}$i++;','foreach',false,$tests,$loops);
compare_commands('While/List + Keys','$test=array(1=>"cat","dog"=>0,"red"=>"green",5=>4,3,"me"); while(list($k,$t) = each($test)){} $i++;','whilelistkeys','foreach + keys','$test=array(1=>"cat","dog"=>0,"red"=>"green",5=>4,3,"me"); foreach($test as $k=>$t){}$i++;','foreachkeys',false,$tests,$loops);
compare_commands('str_replace','$bodytag = str_replace("%body%", "black", "<body text=%body%>");$i++;','strreplace','strtr','$bodytag = strtr("<body text=%body%>","%body%", "black");$i++;','strtr',6,$tests,$loops);
compare_commands('elseif','if($i==0){}elseif($i==1){}elseif($i==2){}elseif($i==3){}elseif($i==4){}elseif($i==5){}elseif($i==6){}elseif($i==7){}elseif($i==8){}elseif($i==9){}else{}$i++;','elseif','switch','switch($i){case 0:break;case 1:break;case 2:break;case 3:break;case 4:break;case 5:break;case 6:break;case 7:break;case 8:break;case 9:break;default:}$i++;','switch',5,$tests,$loops);
compare_commands('Double quotes','$text="das;lfkjasd;lfkjads;lfkjasdl;fkjasdgnafdgljadhsfl;kadsfmasdl;gjkasdfio;mads;klgads;lfgkjads;fkljagl;k";$i++;','double','Single quotes','$text=\'das;lfkjasd;lfkjads;lfkjasdl;fkjasdgnafdgljadhsfl;kadsfmasdl;gjkasdfio;mads;klgads;lfgkjads;fkljagl;k\';$i++;','single',false,$tests,$loops);
compare_commands('GET','$send=$_GET['."'".sent."'".'];$i++;','get','REQUEST','$send=$_REQUEST['."'".sent."'".'];$i++;','request',false,$tests,$loops);
compare_commands('POST','$send=$_POST['."'".received."'".'];$i++;','post','REQUEST','$send=$_REQUEST['."'".received."'".'];$i++;','rrequest',false,$tests,$loops);
compare_commands('Double quotes var','$text="{$i}das;lfkjasd;lfkjads;lfkjasdl;fkjasdgnafdgljadhsfl;kadsfmasdl;gjkasdfio;mads;klgads;lfgkjads;fkljagl;k";$i++;','varrep','Double quotes concat','$text=$i."das;lfkjasd;lfkjads;lfkjasdl;fkjasdgnafdgljadhsfl;kadsfmasdl;gjkasdfio;mads;klgads;lfgkjads;fkljagl;k";$i++;','concat',false,$tests,$loops);
compare_commands('Double quotes concat','$text=$i."das;lfkjasd;lfkjads;lfkjasdl;fkjasdgnafdgljadhsfl;kadsfmasdl;gjkasdfio;mads;klgads;lfgkjads;fkljagl;k";$i++;','dconcat','Single quotes concat','$text=$i.\'das;lfkjasd;lfkjads;lfkjasdl;fkjasdgnafdgljadhsfl;kadsfmasdl;gjkasdfio;mads;klgads;lfgkjads;fkljagl;k\';$i++;','sconcat',false,$tests,$loops);
compare_commands('While/List + reset','if(isset($test)){reset($test);}else{$test=array(1=>"cat","dog"=>0,"red"=>"green",5=>4,3,"me");} while(list(,$t) = each($test)){} $i++;','whilereset','foreach + reset','if(isset($test)){reset($test);}else{$test=array(1=>"cat","dog"=>0,"red"=>"green",5=>4,3,"me");} foreach($test as $t){}$i++;','foreachreset',false,$tests,$loops);
compare_commands('While/List + Keys + reset','if(isset($test)){reset($test);}else{$test=array(1=>"cat","dog"=>0,"red"=>"green",5=>4,3,"me");} while(list($k,$t) = each($test)){} $i++;','wlkr','foreach + keys + reset','if(isset($test)){reset($test);}else{$test=array(1=>"cat","dog"=>0,"red"=>"green",5=>4,3,"me");} foreach($test as $k=>$t){}$i++;','fekr',false,$tests,$loops);
compare_commands('While/List + Keys + reset','if(isset($test)){reset($test);}else{$test=array(1=>"cat","dog"=>0,"red"=>"green",5=>4,3,"me");} while(list($k,$t) = each($test)){} $i++;','wlistkeys','While/List + Keys','$test=array(1=>"cat","dog"=>0,"red"=>"green",5=>4,3,"me"); while(list($k,$t) = each($test)){} $i++;','wlistkeysr',false,$tests,$loops);
compare_commands('foreach + keys','$test=array(1=>"cat","dog"=>0,"red"=>"green",5=>4,3,"me"); foreach($test as $k=>$t){}$i++;','fek','foreach + keys + reset','if(isset($test)){reset($test);}else{$test=array(1=>"cat","dog"=>0,"red"=>"green",5=>4,3,"me");} foreach($test as $k=>$t){}$i++;','fekreset',false,$tests,$loops);
compare_commands('foreach','$test=array(1=>"cat","dog"=>0,"red"=>"green",5=>4,3,"me"); foreach($test as $t){}$i++;','fe','for','$test=array(1=>"cat","dog"=>0,"red"=>"green",5=>4,3,"me"); $keys=array_keys($test); $size=sizeOf($keys); for($a=0; $a<$soze; $a++){$t=$test[$keys[$a]];}$i++;','f',false,$tests,$loops);
compare_commands('elseif==','if($i==0){}elseif($i==1){}elseif($i==2){}elseif($i==3){}elseif($i==4){}elseif($i==5){}elseif($i==6){}elseif($i==7){}elseif($i==8){}elseif($i==9){}else{}$i++;','dequal','elseif===','if($i===0){}elseif($i===1){}elseif($i===2){}elseif($i===3){}elseif($i===4){}elseif($i===5){}elseif($i===6){}elseif($i===7){}elseif($i===8){}elseif($i===9){}else{}$i++;','tequal',23,$tests,$loops);
compare_commands('While','$a=0; while($a<1000){$a++;} $i++;','while','for','for($a=0; $a<1000; $a++){}$i++;','for',2,$tests,$loops);
compare_commands('modify While/List + Keys','$test=array(1=>"cat","dog"=>0,"red"=>"green",5=>4,3,"me"); while(list($k,$t) = each($test)){$test[$k].="a";} $i++;','wlkm','modify foreach + keys','$test=array(1=>"cat","dog"=>0,"red"=>"green",5=>4,3,"me"); foreach($test as $k=>$t){$test[$k].="a";}$i++;','fekm',false,$tests,$loops);
compare_commands('While/List complex','global $array1; $test=$array1; while(list(,$t) = each($test)){} $i++;','wcomplex','foreach complex','global $array1; $test=$array1; foreach($test as $t){}$i++;','fcomplex',false,$tests,$loops);
compare_commands('While/List simple','global $array2; $test=$array2; while(list(,$t) = each($test)){} $i++;','wsimple','foreach simple','global $array2; $test=$array2; foreach($test as $t){}$i++;','fsimple',false,$tests,$loops);
compare_commands('While/List long','global $array3; $test=$array3; while(list(,$t) = each($test)){} $i++;','wlong','foreach long','global $array3; $test=$array3; foreach($test as $t){}$i++;','flong',false,$tests,$loops);
compare_commands('While/List short','global $array4; $test=$array4; while(list(,$t) = each($test)){} $i++;','wshort','foreach short','global $array4; $test=$array4; foreach($test as $t){}$i++;','fshort',false,$tests,$loops);

/*Insert the results into a database*/

//$insert="insert into `benchmarks` (".trim($keys,",").") values (".trim($values,",").");";
//include 'connect.php';
//mysql_query($insert,$cn);

function compare_commands($title1,$code1,$table1,$title2,$code2,$table2,$tablerow=false,$tests=20,$loops=1000)
{
	global $keys;
	global $values;
	$keys.="`$table1`,`$table2`,";									//Add the database column names for the two current commands to the array.
	if(rand(0,1))													//Randomly pick which command to go first.
	{																//Test command one first.
		$t1=doTest($code1,$tests,$loops);							//Run command one through the testing function.
		$t2=doTest($code2,$tests,$loops);							//Basic doTest call is: doTest(Code to test, number of times to run test, number of times to run each loop);
	}
	else															//Otherwise run code two first.
	{
		$t2=doTest($code2,$tests,$loops);
		$t1=doTest($code1,$tests,$loops);
	}
	$values.="'".$t1['time']."','".$t2['time']."',";				//Add the results to the array to be put into the database.
	if(abs($t1['time']-$t2['time'])>($t1['error']+$t2['error']))	//If the time difference between the two commands benchmarks is larger than the margin of error...
	{
		if($t1['time']<$t2['time'])									//If command one is faster...
		{
			$better=round((($t2['time']/$t1['time'])-1)*100,2);		//Calculate and round the percentage difference between the two commands in terms of the faster one.
			$timedifference=(($t2['time']-$t1['time'])/($tests*$loops))*(pow(10,6));	//Calculate the difference in execution time in microseconds between the two commands.
			echo "		<span style='font-weight: bold; color: #6600FF;'>".$title1."</span> is <span style='font-weight: bold; color: #00FF00;'>".$better."%</span> faster than <span style='font-weight: bold; color: #FF0000;'>".$title2."</span> by and average of <span style='font-weight: bold;'>{$timedifference}&#181;s/execution</span>!<br/>";
		}
		else														//If command two is faster...
		{
			$better=round((($t1['time']/$t2['time'])-1)*100,2);		//Calculate and round the percentage difference between the two commands in terms of the faster one.
			$timedifference=(($t1['time']-$t2['time'])/($tests*$loops))*(pow(10,6));	//Calculate the difference in execution time in microseconds between the two commands.
			echo "		<span style='font-weight: bold; color: #6600FF;'>".$title2."</span> is <span style='font-weight: bold; color: #00FF00;'>".$better."%</span> faster than <span style='font-weight: bold; color: #FF0000;'>".$title1."</span> by and average of <span style='font-weight: bold;'>{$timedifference}&#181;s/execution</span>!<br/>";
		}
	}
	else															//Otherwise, if there is no noticable difference between the two commands...
	{
		$timedifference=0;											//Set the time difference to zero and move on.
		echo "		No noticeable difference between <span style='font-weight: bold;'>$title1</span> and <span style='font-weight: bold;'>$title2!</span><br/>\n";
	}
	if($tablerow)													//If one of the two commands appears in my source code for DSR...
	{
		global $totaldifference;
		global $totaloccurences;
		global $totalperpage;
		global $totalperday;
		global $totalperyear;
		echo "			<tr>\n";
		echo "				<td>$title1</td>\n";
		echo "				<td>{$timedifference}&#181;s</td>\n";
		echo "				<td>$tablerow</td>\n";
		$timedifferencep=$timedifference*$tablerow;					//Get the amount of time saved per page load as the average time saved per execution times the number of executions on the page.
		$timedifferenced=($timedifferencep*200)/(pow(10,6));		//Multiply that by 200 to get the time saved per day.
		$timedifferencey=($timedifferenced*365.25);					//Multiply that by 365.25 to get the time saved per year.
		echo "				<td>{$timedifferencep}&#181;s</td>\n";
		echo "				<td>{$timedifferenced}s</td>\n";
		echo "				<td>{$timedifferencey}s</td>\n";
		echo "			</tr>\n";
		$totaldifference+=$timedifference;							//Add the amount of time saver for this command to the total amount of time saved.
		$totaloccurences+=$tablerow;								//Add the number of occurences for this command to the total amount.
		$totalperpage+=$timedifferencep;							//Do the same for per page, per day and per year.
		$totalperday+=$timedifferenced;
		$totalperyear+=$timedifferencey;
	}
}
function doTest($in,$tests,$loops)									//This function does the actual testing.
{
	$num_tests_done=0;												//Set the counting variable $num_tests_done--which records the number of tests done--to zero.
	$num_tests_to_do=$tests;										//$num_tests_to_do is the total number of tests to be done for this command.
	$loop=$loops;													//$loop is the number of times to run the command through the loop for each test.
	while($num_tests_done<$num_tests_to_do)							//Keep testing until we've done as many as desired.
	{
		$time_start = microtime(true);								//Get the current time in microseconds.
		
		$i=0;														//Set the counting variable $i--which holds the number of times the loop has been done--to zero.
		while($i<$loop)												//Until we've done all the desired loops...
		{
			eval($in);												//Execute the input code. NOTE: The input code must bump the variable $i in order for this loop to ever exit.
		}
		
		$time[] = (microtime(true) - $time_start);					//Calculate the total time taken to run through the loop.
		$num_tests_done++;											//Add one to the variable that stores the number of tests done and continue.
	}
	$average=array_sum($time)/count($time);							//Calculate the average execution time.
	foreach($time as $t)											//For each benchmark...
	{
		$margin[]=abs($average-$t);									//Get the difference between the average speed and the current speed.
	}
	$average_error=array_sum($margin)/count($margin);				//Calculate the average margin of error as the average difference between the average speed and each speed.
	$out=array("time"=>$average,"error"=>$average_error);			//Put the results in an array to send back.
	return $out;
}
echo "			<tr>\n";
echo "				<td>Total:</td>\n";
echo "				<td>{$totaldifference}&#181;s</td>\n";
echo "				<td>{$totaloccurences}</td>\n";
echo "				<td>{$totalperpage}&#181;s</td>\n";
echo "				<td>{$totalperday}s</td>\n";
echo "				<td>{$totalperyear}s</td>\n";
echo "			<tr/>\n";
echo "		</table>\n";
echo "	</body>\n";
echo "</html>\n";
?>